`timescale 1ns / 1ps
//*****************************************************************************
// File Name            : da_e_pwm.v
//-----------------------------------------------------------------------------
// Function             : exp^da -> pwm
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2013/01/10 
//*****************************************************************************
module da_e_pwm(
  input clk,
  input reset_n,
  input [3:0]din_a,
  input [3:0]din_b,
  input [3:0]din_c,
  output pwm
);

wire pwm_a;
wire pwm_b;
wire pwm_c;
reg [5:0] rst_cnt;
reg  rstn_a;
reg  rstn_b;
reg  rstn_c;

always @(posedge clk or negedge reset_n) begin
  if( !reset_n ) 
    rst_cnt<=0;
  else
    if (rst_cnt != 6'd63)
	  rst_cnt <= rst_cnt + 6'd1;
	else
	  rst_cnt <= rst_cnt;
end	


always @(posedge clk or negedge reset_n) begin
  if( !reset_n ) 
     rstn_a <=0;
  else
    if  (rst_cnt == 6'd1)
      rstn_a <=1;
	else
      rstn_a <= rstn_a;
end
	 

always @(posedge clk or negedge reset_n) begin
  if( !reset_n ) 
     rstn_b <=0;
  else
    if  (rst_cnt == 6'd21)
      rstn_b <=1;
	else
     rstn_b <= rstn_b;
end


always @(posedge clk or negedge reset_n) begin
  if( !reset_n ) 
     rstn_c <=0;
  else
    if  (rst_cnt == 6'd42)
      rstn_c <=1;
	else
     rstn_c <= rstn_c;
end
	 
	da_e_pwm_ch pwm_a_u (
		.clk(clk), 
		.reset_n(rstn_a), 
		.din(din_a), 
		.pwm(pwm_a)
	);
	

	da_e_pwm_ch pwm_b_u (
		.clk(clk), 
		.reset_n(rstn_b), 
		.din(din_b), 
		.pwm(pwm_b)
	);
	
	da_e_pwm_ch pwm_c_u (
		.clk(clk), 
		.reset_n(rstn_c), 
		.din(din_c), 
		.pwm(pwm_c)
	);
	
assign pwm = pwm_a || pwm_b || pwm_c;

endmodule
